/**********************************************************************



  Filename:  complex1.cpp

  Chapter:   1      Overview of C++ and Object Oriented Programming

  Section:   1.4    Classes and Abstract Data Types

  Compiler:  Borland C++     Version 5.0       Summer 1996

  C++ for Fortran Programmers    By Ira Pohl



********************************************************************/



//Test of the class complex.

//An elementary implementation of type complex.

#include <iostream.h>

class complex {

public:       //universal access to interface

//constructor

   complex(double r = 0, double im = 0):

   real(r), imaginary(im){}

//destructor

   ~complex(){cout << "destructor "; print();}

   void re_assign(double r){real = r;}

   void im_assign(double im){imaginary = im;}

   void print() const

     {  cout << "(" << real<< "," << imaginary << "i)" << endl;}

   void print(const char* id)const

     { cout << id << " = "; print(); }



   friend complex operator+(complex, complex);

private://restricted access to implementation

   double real, imaginary;

};



//overload +

complex operator+(complex x, complex y)

{

  complex t;



  t.real = x.real + y.real;

  t.imaginary = x.imaginary + y.imaginary;

  return t;

}



int main()

{

   complex x(5.5, 1.0), y, z;



   y.re_assign(4.2);

   y.im_assign(6.0);

   z = x + y;    //uses operator+()

   x.print();

   y.print("x");

   z.print();

}



