/**********************************************************************



  Filename:  stackex.cpp

  Chapter:   1      Overview of C++ and Object Oriented Programming

  Section:   1.11   Exceptions

  Compiler:  Borland C++     Version 5.0       Summer 1996

  C++ for Fortran Programmers    By Ira Pohl



********************************************************************/



//template stack implementation

#include <iostream.h>

enum boolean { false, true };



class stack {

public:

   stack(int n);

   ~stack() { delete []p; }

   void  reset() { top = EMPTY; }

   void  push(char c) { p[++top] = c; }

   char  pop() { return p[top--]; }

   char  top_of() { return p[top]; }

   boolean  empty() { return boolean(top == EMPTY); }

   boolean  full() { return boolean(top == max_len - 1); }

private:

   enum   {EMPTY = -1};

   char*  p;

   int    max_len;

   int    top;

};





//stack constructor with exceptions

stack::stack(int n)

{

   if (n < 1)

      throw (n);        //want a positive value

   p = new char[n];     //create a stack of characters

   max_len =  n;

   top = EMPTY;

   if (p == 0)          //new returns 0 when it fails

      throw ("FREE STORE EXHAUSTED");

}





main()

{

    try {

      stack  a(5);



	char ch =  'A';



   while (!a.full())

      a.push(ch++);

   cout << "\na stack is ";

   while (!a.empty())

      cout << a.pop() << '\t';



   //  int n = 10;     //this should run ok

   int n = -10;        //should give an error



   stack  b(n);        //if n is negative or 0, then give error



   ch = 'a';

   while (!b.full())

      b.push(ch++);



    cout << "\nb stack is ";

   while (!b.empty())

      cout << b.pop() << '\t';



   } catch (int n) { cout << "\nWrong size = " << n ; } //an incorrect size

     catch (char*) { cout << "\nOut of memory" ;}  //couldn't get it

   return 0;

}

