/**********************************************************************



  Filename:  dbl_vect1.h

  Chapter:   5      Constructors and Destructors

  Section:   5.5    A class vect

  Compiler:  Borland C++     Version 5.0       Winter 1997

  C++ for Fortran Programmers    By Ira Pohl



********************************************************************/



//Implementation of a safe array type dbl_vect

#include  <iostream.h>

#include  <assert.h>



class dbl_vect {

public:

   explicit dbl_vect(int n = 10);

   ~dbl_vect() { delete []p; }

   double& element(int i);                //access p[i]

   int ub() const { return (size - 1); }   //upper bound

   void print() const;

   double dot_prod(const dbl_vect& v) const;

private:

   double*p;

   double size;

};



dbl_vect::dbl_vect(int n) : size(n)

{

   assert(n > 0);

   p = new double[size];

   assert(p != 0);

}





double& dbl_vect::element(int i)

{

   assert (i >= 0 && i < size);

   return p[i];

}



void dbl_vect::print()const

{

   cout << " vector of size " << size << endl;

   for (int i = 0; i <size; ++i)

   cout << p[i] << "\t";

}



double dbl_vect::dot_prod(const dbl_vect& v) const

{

   assert(size == v.size);

   double sum = 0.0;



   for (int i = 0; i < size; ++i)

      sum += p[i] * v.p[i];

   return sum;

}

