/**********************************************************************



  Filename:  functor.cpp

  Chapter:   5      Constructors and Destructors

  Section:   5.5    A class functor

  Compiler:  Borland C++     Version 5.0       Summer 1996

  C++ for Fortran Programmers    By Ira Pohl



********************************************************************/



//create a class that represents a function

#include <iostream.h>

#include <assert.h>



double f(double x)

   { return (x*x + 1.0/x);}

double g(double x)

   { return (3*x*x -2*x + 4);}



class functor {

public:

  functor(double f(double)) : fcn(f){}

  void plot(double x0, double x1, double incr);

private:

  double (*fcn)(double);

};



void functor::plot(double x0, double x1, double incr)

{

   assert(x0 < x1 && incr > 0);

   for (; x0 <= x1 ; x0 += incr) {

      cout << " f(" << x0 << ") = " << fcn(x0) << endl;

   }

}



int main()

{

    functor fctr(f), gctr(g);

    cout << "mapping functions x*x + 1.0/x " << endl;

    fctr.plot(0.01, 2.01, 0.01);

    cout << "mapping functions 3*x*x -2*x + 4 " << endl;

    gctr.plot(0.00, 2.01, 0.01);

}

