/**********************************************************************



  Filename:  vec.h

  Chapter:   7      Visitation Iterators and Containers

  Section:   X      

  Compiler:  Borland C++     Version 5.0       Summer 1996

  C++ for Fortran Programmers    By Ira Pohl



********************************************************************/



/*********************************************************************

  Filename:  vec.h

  Chapter:   7      Visitation Iterators and Containers

  Section:   7.7    Numerical integration using vector

  Compiler:  Borland C++     Version 5.0       Summer 1996

  C++ for Fortran Programmers    By Ira Pohl

*********************************************************************

//vec.h

#include <iostream.h>

class vector {

public:

   typedef double* iterator; //pointer vector::double*

   explicit vector(int n = 1);

   vector(const vector& v);

   vector(const double a[], int n);

   ~vector() { delete []bp; }

   iterator begin()const {return bp;}

   iterator end()const {return bp + size;}

   int  ub()const {return size - 1;}//upper bound

   double& operator[](int i); //range checked

   vector& operator=(const vector& v);

private:

   iterator bp; //base pointer

   int size; //number of elements

};



ostream& operator<<(ostream& out, const vector& v)

{

   vector::iterator p;



   for (p = v.begin(); p != v.end(); ++p)

      out << *p << '\t';

   out << endl;

   return out;

}



istream& operator>>(istream& in, vector& v)

{

   vector::iterator p;



   for (p = v.begin(); p != v.end(); ++p)

      in >> *p;

   return in;

}

