/**********************************************************************



  Filename:  stack.h

  Chapter:   C      Appendix C - Fortran 90 and C++

  Section:   C.8    Units and Objects

  Compiler:  Borland C++     Version 5.0       Summer 1996

  C++ for Fortran Programmers    By Ira Pohl



********************************************************************/



//Use member functions on stack example from chapter 4

#include <iostream.h>

const int max_len = 1000;

enum boolean {false, true};



class stack {

public:

//the public interface for the ADT stack

//operations represented as member functions

   stack () { top = EMPTY; }

   void  reset() { top = EMPTY; }

   void  push(char c) { top++; s[top] = c; }

   char  pop() { return s[top--]; }

   char  top_of() { return s[top]; }

   boolean  empty() { return (boolean(top == EMPTY)); }

   boolean  full() { return (boolean(top == FULL)); }

   void print() const;

private:

   char  s[max_len];

   int   top;

   enum { EMPTY = -1, FULL = max_len - 1 };



};



void stack::print() const

{

   cout << "stack contents:\n";

   if (top != EMPTY)

      for (int i = 0; i <= top; ++i)

         cout << s[i] << endl;

}



